declare const isNode: () => boolean;
/**
 * Converts a string such that each of its characters are represented as hex.
 *
 * @param value - the string to convert to hex.
 * @returns the hex encoded version of the string.
 */
export declare const stringToHex: (value: string) => string;
/**
 * Converts a string that is optionally in hex format into a Uint8Array.
 *
 * @param value - the string to convert to a Uint8Array.
 * @param isHex - flag to indicate it's a hex string or not.
 * @returns the Uint8Array value.
 */
export declare const stringToUint8Array: (value?: string | undefined, isHex?: boolean | undefined) => Uint8Array | undefined;
export default isNode;
