/**
 * Types of errors that originate from PayID.
 */
export declare enum PayIdErrorType {
    InvalidPayId = 0,
    MappingNotFound = 1,
    UnexpectedResponse = 2,
    Unimplemented = 3,
    Unknown = 4
}
/**
 * Represents errors thrown by PayID components of the Xpring SDK.
 */
export default class PayIdError extends Error {
    readonly errorType: PayIdErrorType;
    /**
     * Default errors.
     */
    static unimplemented: PayIdError;
    static invalidPayId: PayIdError;
    /**
     * @param errorType The type of error.
     * @param message The error message.
     */
    constructor(errorType: PayIdErrorType, message?: string | undefined);
}
