import { GetAccountInfoRequest, GetAccountInfoResponse } from '../Generated/node/org/xrpl/rpc/v1/get_account_info_pb';
import { GetFeeRequest, GetFeeResponse } from '../Generated/node/org/xrpl/rpc/v1/get_fee_pb';
import { SubmitTransactionRequest, SubmitTransactionResponse } from '../Generated/node/org/xrpl/rpc/v1/submit_pb';
import { AccountAddress } from '../Generated/node/org/xrpl/rpc/v1/account_pb';
import { GetAccountTransactionHistoryRequest, GetAccountTransactionHistoryResponse } from '../Generated/node/org/xrpl/rpc/v1/get_account_transaction_history_pb';
import { GetTransactionRequest, GetTransactionResponse } from '../Generated/node/org/xrpl/rpc/v1/get_transaction_pb';
import { GrpcNetworkClientInterface } from './grpc-network-client-interface';
/**
 * A GRPC Based network client.
 */
export default class GrpcXrpNetworkClient implements GrpcNetworkClientInterface {
    private readonly grpcClient;
    constructor(grpcURL: string);
    getAccountInfo(request: GetAccountInfoRequest): Promise<GetAccountInfoResponse>;
    getFee(request: GetFeeRequest): Promise<GetFeeResponse>;
    getTransaction(request: GetTransactionRequest): Promise<GetTransactionResponse>;
    submitTransaction(request: SubmitTransactionRequest): Promise<SubmitTransactionResponse>;
    getTransactionHistory(request: GetAccountTransactionHistoryRequest): Promise<GetAccountTransactionHistoryResponse>;
    AccountAddress(): AccountAddress;
    GetAccountInfoRequest(): GetAccountInfoRequest;
    GetTransactionRequest(): GetTransactionRequest;
    GetFeeRequest(): GetFeeRequest;
    SubmitTransactionRequest(): SubmitTransactionRequest;
    GetAccountTransactionHistoryRequest(): GetAccountTransactionHistoryRequest;
}
