import { CheckCancel } from '../Generated/web/org/xrpl/rpc/v1/transaction_pb';
export default class XrpCheckCancel {
    readonly checkId: string;
    /**
     * Constructs an XrpCheckCancel from a CheckCancel protocol buffer.
     *
     * @param checkCancel a CheckCancel (protobuf object) whose field values will be used to construct an XrpCheckCancel
     * @return an XrpCheckCancel with its fields set via the analogous protobuf fields.
     * @see https://github.com/ripple/rippled/blob/3d86b49dae8173344b39deb75e53170a9b6c5284/src/ripple/proto/org/xrpl/rpc/v1/transaction.proto#L126
     */
    static from(checkCancel: CheckCancel): XrpCheckCancel;
    /**
     * @param checkId The ID of the Check ledger object to cancel, as a 64-character hexadecimal string.
     */
    private constructor();
}
