import { OfferCancel } from '../Generated/web/org/xrpl/rpc/v1/transaction_pb';
export default class XrpOfferCancel {
    readonly offerSequence: number;
    /**
     * Constructs an XrpOfferCancel from an OfferCancel protocol buffer.
     *
     * @param offerCancel an OfferCancel (protobuf object) whose field values will be used to construct an XrpOfferCancel
     * @return an XrpOfferCancel with its fields set via the analogous protobuf fields.
     * @see https://github.com/ripple/rippled/blob/3d86b49dae8173344b39deb75e53170a9b6c5284/src/ripple/proto/org/xrpl/rpc/v1/transaction.proto#L206
     */
    static from(offerCancel: OfferCancel): XrpOfferCancel;
    /**
     * @param offerSequence The sequence number of a previous OfferCreate transaction. If specified,
     *                      cancel any offer object in the ledger that was created by that transaction.
     *                      It is not considered an error if the offer specified does not exist.
     */
    private constructor();
}
