import { Payment } from '../Generated/web/org/xrpl/rpc/v1/transaction_pb';
import XrpPathElement from './xrp-path-element';
declare type Path = Payment.Path;
export default class XrpPath {
    readonly pathElements: Array<XrpPathElement>;
    /**
     * Constructs an XrpPath from a Path.
     *
     * @param path a Path (protobuf object) whose field values will be used
     *             to construct an XrpPath
     * @returns an XrpPath with its fields set via the analogous protobuf fields.
     * @see https://github.com/ripple/rippled/blob/develop/src/ripple/proto/org/xrpl/rpc/v1/transaction.proto#L237
     */
    static from(path: Path): XrpPath;
    /**
     *
     * @param pathElements List of XrpPathElements that make up this XRPPath.
     */
    private constructor();
}
export {};
