import { SetRegularKey } from '../Generated/web/org/xrpl/rpc/v1/transaction_pb';
export default class XrpSetRegularKey {
    readonly regularKey?: string | undefined;
    /**
     * Constructs an XrpSetRegularKey from a SetRegularKey protocol buffer.
     *
     * @param setRegularKey a SetRegularKey (protobuf object) whose field values will be used to construct an XrpSetRegularKey
     * @return an XrpSetRegularKey with its fields set via the analogous protobuf fields.
     * @see https://github.com/ripple/rippled/blob/3d86b49dae8173344b39deb75e53170a9b6c5284/src/ripple/proto/org/xrpl/rpc/v1/transaction.proto#L298
     */
    static from(setRegularKey: SetRegularKey): XrpSetRegularKey;
    /**
     * @param regularKey (Optional) A base-58-encoded Address that indicates the regular key pair to be assigned to the account.
     *                    If omitted, removes any existing regular key pair from the account.
     *                    Must not match the master key pair for the address.
     */
    private constructor();
}
