"use strict";
/* eslint-disable no-bitwise */
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Flags used in payment transactions.
 *
 * @note These are only flags which are utilized in Xpring SDK.
 * For the full list of payment flags, @see https://xrpl.org/payment.html#payment-flags
 *
 */
class PaymentFlags {
    /**
     * Check if the given flag is set in the given set of bit-flags.
     *
     * @param flag: The flag to check the presence of.
     * @param flags: The flags to check
     */
    static checkFlag(flag, flags) {
        return (flag & flags) === flag;
    }
}
PaymentFlags.TF_PARTIAL_PAYMENT = 1 << 17;
exports.default = PaymentFlags;
//# sourceMappingURL=payment-flags.js.map