import { GetTransactionResponse } from '../Generated/web/org/xrpl/rpc/v1/get_transaction_pb';
/** Abstraction around raw Transaction Status for compatibility. */
export default class RawTransactionStatus {
    isValidated: boolean;
    transactionStatusCode: string;
    lastLedgerSequence: number | undefined;
    isFullPayment: boolean;
    /**
     * Create a RawTransactionStatus from a GetTransactionResponse protocol buffer.
     */
    static fromGetTransactionResponse(getTransactionResponse: GetTransactionResponse): RawTransactionStatus;
    /**
     * Note: This constructor is exposed for testing purposes. Clients of this code should favor using a static factory method.
     */
    constructor(isValidated: boolean, transactionStatusCode: string, lastLedgerSequence: number | undefined, isFullPayment: boolean);
}
