/** Represents statuses of transactions. */
declare enum TransactionStatus {
    /** The transaction did not achieve its intended purpose, but the transaction cost was destroyed. */
    ClaimedCostOnly = 0,
    /** The transaction is not included in a finalized ledger, and is not valid, due to improper syntax, conflicting options, a bad signature, or something else. */
    MalformedTransaction = 1,
    /** The transaction was included in a finalized ledger and failed. */
    Failed = 2,
    /** The transaction is not included in a finalized ledger. */
    Pending = 3,
    /** The transaction was included in a finalized ledger and succeeded. */
    Succeeded = 4,
    /** The transaction's last ledger sequence has been surpassed; the transaction will never be included in a validated ledger. */
    LastLedgerSequenceExpired = 5,
    /** The transaction was included in a finalized ledger and succeeded. */
    Unknown = 6
}
export default TransactionStatus;
