"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/** Represents statuses of transactions. */
var TransactionStatus;
(function (TransactionStatus) {
    /** The transaction did not achieve its intended purpose, but the transaction cost was destroyed. */
    TransactionStatus[TransactionStatus["ClaimedCostOnly"] = 0] = "ClaimedCostOnly";
    /** The transaction is not included in a finalized ledger, and is not valid, due to improper syntax, conflicting options, a bad signature, or something else. */
    TransactionStatus[TransactionStatus["MalformedTransaction"] = 1] = "MalformedTransaction";
    /** The transaction was included in a finalized ledger and failed. */
    TransactionStatus[TransactionStatus["Failed"] = 2] = "Failed";
    /** The transaction is not included in a finalized ledger. */
    TransactionStatus[TransactionStatus["Pending"] = 3] = "Pending";
    /** The transaction was included in a finalized ledger and succeeded. */
    TransactionStatus[TransactionStatus["Succeeded"] = 4] = "Succeeded";
    /** The transaction's last ledger sequence has been surpassed; the transaction will never be included in a validated ledger. */
    TransactionStatus[TransactionStatus["LastLedgerSequenceExpired"] = 5] = "LastLedgerSequenceExpired";
    /** The transaction was included in a finalized ledger and succeeded. */
    TransactionStatus[TransactionStatus["Unknown"] = 6] = "Unknown";
})(TransactionStatus || (TransactionStatus = {}));
exports.default = TransactionStatus;
//# sourceMappingURL=transaction-status.js.map