"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Represents a trust line on the XRP Ledger.
 * @see https://xrpl.org/trust-lines-and-issuing.html
 */
class TrustLine {
    constructor(trustLineJson) {
        this.account = trustLineJson.account;
        this.balance = trustLineJson.balance;
        this.currency = trustLineJson.currency;
        this.limit = trustLineJson.limit;
        this.limitPeer = trustLineJson.limit_peer;
        this.qualityIn = trustLineJson.quality_in;
        this.qualityOut = trustLineJson.quality_out;
        this.noRipple = !!trustLineJson.no_ripple;
        this.noRipplePeer = !!trustLineJson.no_ripple_peer;
        this.authorized = !!trustLineJson.authorized;
        this.peerAuthorized = !!trustLineJson.peer_authorized;
        this.freeze = !!trustLineJson.freeze;
        this.freezePeer = !!trustLineJson.freeze_peer;
    }
}
exports.default = TrustLine;
//# sourceMappingURL=trustline.js.map