/**
 * Types of transactions on the XRP Ledger.
 *
 * This is a partial list. Please file an issue if you have a use case that requires additional types.
 *
 * @see: https://xrpl.org/transaction-formats.html
 */
declare enum XrpTransactionType {
    Payment = 0,
    AccountSet = 1,
    AccountDelete = 2,
    CheckCancel = 3,
    CheckCash = 4,
    CheckCreate = 5,
    DepositPreauth = 6,
    EscrowCancel = 7,
    EscrowCreate = 8,
    EscrowFinish = 9,
    OfferCancel = 10,
    OfferCreate = 11,
    PaymentChannelClaim = 12,
    PaymentChannelCreate = 13,
    PaymentChannelFund = 14,
    SetRegularKey = 15,
    SignerListSet = 16,
    TrustSet = 17
}
export default XrpTransactionType;
